/*
 * CoNLLDocumentReader.cpp
 *
 *  Created on: Sep 11, 2013
 *      Author: bishan
 */

#include "CoNLLDocumentReader.h"
#include <fstream>
#include <assert.h>
#include <stack>

CoNLLDocumentReader::CoNLLDocumentReader(string filename) {
	// TODO Auto-generated constructor stub
	infile.open(filename.c_str(), ios::in);
}

CoNLLDocumentReader::~CoNLLDocumentReader() {
	// TODO Auto-generated destructor stub
}

void CoNLLDocumentReader::ReadDocument(vector<Sentence*> &sents) {
	string line;
	while (getline(infile, line) && line.find("#begin document") == string::npos) {
		cout<<line<<endl;

	}
	if (line == "") return;

	int start_index = line.find('(');
	int end_index = line.find(')');
	string doc_id = line.substr(start_index+1, end_index-start_index-1);

	// Read sentences.
	int sent_id = 0;
	string sent_str = "";
	while (getline(infile, line) && line.find("#end document") == string::npos) {
		if (line == "") {
			if(ReadSentence(sent_str, sent_id, sents)) {
				sent_id ++;
			}
			sent_str = "";
		} else {
			sent_str += line + "\n";
		}
	}
}

bool CoNLLDocumentReader::ReadSentence(string sent_str, int sent_id, vector<Sentence*> &sents) {
	Sentence *sent = new Sentence();
	vector<string> lines;
	Utils::Split(sent_str, '\n', lines);

	string parse_tree = "";
	for (int i = 0; i < lines.size(); ++i) {
		vector<string> fields;
		Utils::Split(lines[i], '\t', fields);

		if (fields.size() < 7) {
			cout<<"sentence format wrong!!!"<<endl;
			cout<<lines[i]<<endl;
			return false;
		}
		string word = fields[WORD];
		string pos = fields[POS_TAG];
		string lemma = Dictionary::getLemma(word, pos);

		sent->words.push_back(word);
		sent->postags.push_back(pos);
		sent->lemmas.push_back(lemma);

		// Read parse tree info.
		string parse_tag = fields[PARSE_TAG];
		int index = parse_tag.find('*');
		if (index >= 0) {
			parse_tree += parse_tag.substr(0, index) +
					"(" + pos + "[" + word + "/" + pos + "]" + " " + word + ")"
					+ parse_tag.substr(index+1);
		}

		// Read coref mentions.
		sent->token_labels.push_back(fields[fields.size()-1]);
	}

	// Build parse tree.
	if (parse_tree != "")
		sent->buildPennTree(parse_tree);

	sents.push_back(sent);

	return true;
}
