/*
 * CoNLLDocumentReader.h
 *
 *  Created on: Sep 11, 2013
 *      Author: bishan
 */

#ifndef CONLLDOCUMENTREADER_H_
#define CONLLDOCUMENTREADER_H_

#include <string>
#include <vector>
#include <map>

#include "Sentence.h"
#include "./Parsing/Utils.h"

using namespace std;

enum FieldType { WORD, POS_TAG, PARSE_TAG};

#define FIELDS_MIN 12

class CoNLLDocumentReader {
public:
	CoNLLDocumentReader(string filename);
	virtual ~CoNLLDocumentReader();

	void ReadDocument(vector<Sentence*> &sents);
private:
	ifstream infile;
	bool ReadSentence(string line, int sent_id, vector<Sentence*> &sents);
};

#endif /* CONLLDOCUMENTREADER_H_ */
