/*
 * Dataset.cpp
 *
 *  Created on: Nov 9, 2012
 *      Author: babishan
 */
#include "Dataset.h"

#include <fstream>
#include <set>
#include <math.h>

Dataset::Dataset() {
	// TODO Auto-generated constructor stub
}

Dataset::~Dataset() {
	// TODO Auto-generated destructor stub

	for (int i = 0; i < sentences.size(); ++i) {
		delete sentences[i];
		sentences[i] = NULL;
	}
}

void Dataset::CollectTaggingLabels(set<string> &ylabels) {
	ylabels.clear();
	for (int i = 0; i < sentences.size(); ++i) {
		for (int j = 0; j < sentences[i]->token_labels.size(); ++j) {
			ylabels.insert(sentences[i]->token_labels[j]);
		}
	}
}

void Dataset::CollectEntities(string labelscheme) {
	for (int i = 0; i < sentences.size(); ++i) {
		sentences[i]->entities = Utils::getSpans(sentences[i]->token_labels, labelscheme);
	}
}

Sentence* Dataset::ParseSent(string sentstr) {
	Sentence *sent = new Sentence();
	vector<string> lines;
	Utils::Split(sentstr, '\n', lines);

	string parse_tree = "";
	for (int i = 0; i < lines.size(); ++i) {
		vector<string> fields;
		Utils::Split(lines[i], '\t', fields);

		if (fields.size() < 3) {
			cout<<"sentence format wrong!!!"<<endl;
			cout<<lines[i]<<endl;
			return NULL;
		}
		string word = fields[WORD];
		string pos = fields[POS_TAG];
		string lemma = Dictionary::getLemma(word, pos);

		sent->words.push_back(word);
		sent->postags.push_back(pos);
		sent->lemmas.push_back(lemma);

		if (fields.size() > 3) {
			// Read parse tree info.
			string parse_tag = fields[PARSE_TAG];
			int index = parse_tag.find('*');
			if (index >= 0) {
				parse_tree += parse_tag.substr(0, index) +
						"(" + pos + "[" + word + "/" + pos + "]" + " " + word + ")"
						+ parse_tag.substr(index+1);
			}
		}

		sent->token_labels.push_back(fields[fields.size()-1]);
	}

	// Build parse tree.
	if (parse_tree != "") {
		sent->buildPennTree(parse_tree);
	}

	return sent;
}

void Dataset::LoadCRFData(string filename) {
	sentences.clear();

	ifstream infile(filename.c_str(), ios::in);

	string line = "";
	while (getline(infile, line)) {
		// Read sentences.
		int sent_id = 0;
		string sent_str = line + "\n";
		while (getline(infile, line) && line != "") {
			sent_str += line + "\n";
		}
		Sentence *sent = ParseSent(sent_str);
		if (sent != NULL) sentences.push_back(sent);
	}

	infile.close();
}

